<?php

# $Id: survey_export_csv.inc,v 1.5 2002/04/28 20:43:04 jimmerman Exp $

// Written by James Flemer
// <jflemer@acm.jhu.edu>

/* {{{ proto array survey_generate_csv(int survey_id)
	Exports the results of a survey to an array.
	*/
function survey_generate_csv($sid,$idcurso="",$idmodulo="") {

	$output = array();
	$columns = array();
	$types = array();
	$arr = array();
	
	$id_to_csv_map = array(
		'0',	// 0: unused
		'1',	// 1: bool -> boolean
		'1',	// 2: text -> string
		'1',	// 3: essay -> string
		'1',	// 4: radio -> string
		'1',	// 5: check -> string
		'1',	// 6: dropdn -> string
		'0',	// 7: rating -> number
		'0',	// 8: rate -> number
		'1',	// 9: date -> string
		'0' 	// 10: numeric -> number
	);
  //Saca las preguntas de la encuesta asociada con $sid - 
	$sql = "SELECT q.id, q.name, q.type_id
		FROM question q
		WHERE q.survey_id = $sid AND
		q.deleted = 'N' AND q.type_id < 50
		ORDER BY position";
		
	
		
	$result = mysql_query($sql);
	$numcols = mysql_num_rows($result);
	while( list( $qid, $col, $type ) = mysql_fetch_row($result) ) {
		if ($type == 8) {
			/* rate */
			$sql = "SELECT CONCAT(q.name, '_', c.content)
			FROM question q, question_choice c
			WHERE q.id = $qid AND q.id = c.question_id";
			$result2 = mysql_query($sql);
			$numcols += mysql_num_rows($result2) - 1;
			while( list($col) = mysql_fetch_row($result2) ) {
				$str1 = $col;
				do {
					$str2 = $str1;
					$str1 = eregi_replace(
					"(^| )(what|which|why|how|who|where|how|is|are|were|the|a|it|of|do|you|your|please|enter)[ ?]", 
					" ", $str2);
				} while ($str1 != $str2);
				$col = $str1;
				$col = strtoupper(eregi_replace(
					"[^A-Z0-9]+", "_", trim($col)));
				$col = ereg_replace('_$',"",$col);
				array_push($columns, $col);
				array_push($types, $id_to_csv_map[$type]);
			}
			mysql_free_result($result2);
		} else {
		
		/* ********************************************************************
		CAMBIO REALIZADO POR: CARLOS H. CERON MEZA
		**************************************************************** */
		 
		  if($type==5) //si es checkbox
		  {
          $sql = "SELECT * 
                  FROM `question_choice` 
                  WHERE `question_id` =$qid
                  ";
          $result_check = mysql_query($sql);
	        $num_columnas = mysql_num_rows($result_check);
	        
	        //COLOCO EN EL ARREGLO LOS NOMBRES DE LAS COLUMNAS CUANDO SON CHECKBOXES
          array_push($columns, $col);
			    array_push($types, $id_to_csv_map[$type]);
	        for($i=2;$i<=$num_columnas;$i++)
	        {
                array_push($columns, "$col"."_$i");
			          array_push($types, $id_to_csv_map[$type]);
			     } 
          
      }
		
		else
    {
		   if ($_SESSION["grupo"]=="Ceddet")
		    {
		      if (($col!="IDU")&&($col!="NU")){
			     array_push($columns, $col);
			     array_push($types, $id_to_csv_map[$type]);
			    }
		    } //if
			  else
			  {
           array_push($columns, $col);
			     array_push($types, $id_to_csv_map[$type]);
        } //else
      } //else
		} //else
	} //while
	
	mysql_free_result($result);		
	$num = 0;
	
	array_push($output, $columns);

	$sql = "SELECT id FROM response 
		WHERE survey_id='$sid' AND complete='Y'
		ORDER BY submitted";
		
	//if ($sid==1248)
	 //$sql.=" limit 100";
  
  	
	$result = mysql_query($sql);
	$arreglo_usuarios = array();
    
    while($row = mysql_fetch_row($result)) 
  {
		// get the response
		$response = response_select_named($sid, $row[0]);
		
		
    $arr = array();
    
		

		if ($idcurso!="" && $idmodulo!="")
		{//ES PARA EL CEDDET
		$ceddet=1;
		  if (($response["IDC"]==$idcurso)&&($response["IDM"]==$idmodulo))
		  {
		    $arreglo_usuarios[]=$response['IDU'];
		  
			// merge it
		  for($i = 0; $i < $numcols; $i++) {
			if (isset($response[$columns[$i]]) && is_array($response[$columns[$i]]))
			{
          		   /*
           COLOCO EN EL VECTOR RESULTADO LAS COLUMNAS QUE SELECCION EL USUARIO CUANDO SON CHECKBOXES, ESTO SE HACE PARA QUE SALGA CADA OPCION EN UNA COLUMNA DIFERENTE Y NO SEPARADO POR COMAS
           */
           $arreglo = Array();
           $arreglo = $response[$columns[$i]];
				   $k=0;			   
				   $response[$columns[$i]]=$response[$columns[$i]][$k];
				   $k++;
            for($j=2;$j<=sizeof($arreglo);$j++)
            {
            
             
              $response[$columns[$i]."_$j"]=$arreglo[$k];
              array_push($arr, $response[$columns[$i]."_$j"]);
              $k++;
                  
            }
      
      }
				 // chcm 12 Junio 2007  $response[$columns[$i]] = join(',', $response[$columns[$i]]);
			switch ($types[$i]) {
			case 2: /* special */
				break;
			case 1: /* string */
				if (isset($response[$columns[$i]])) {
					$response[$columns[$i]] = ereg_replace("[\n\t]", ' ', $response[$columns[$i]]);
					$response[$columns[$i]] = ereg_replace('"', '""', $response[$columns[$i]]);
					$response[$columns[$i]] = '"'. $response[$columns[$i]] .'"';
				}
				/* fall through */
			case 0: /* number */
				if (isset($response[$columns[$i]]))
					array_push($arr, $response[$columns[$i]]);
				else
					array_push($arr, '');
				break;
			}
		} // for 
	
		} // if
		else {}
		} // if ($idcurso!="" && $idmodulo!="")
		else
		{
		  // i($response);
        for($i = 0; $i < $numcols; $i++) {
        
		  	if (isset($response[$columns[$i]]) && is_array($response[$columns[$i]]))
				{
				  
				   /*
           COLOCO EN EL VECTOR RESULTADO LAS COLUMNAS QUE SELECCION EL USUARIO CUANDO SON CHECKBOXES, ESTO SE HACE PARA QUE SALGA CADA OPCION EN UNA COLUMNA DIFERENTE Y NO SEPARADO POR COMAS
           */
           $arreglo = Array();
           $arreglo = $response[$columns[$i]];
				   $k=0;			   
				   $response[$columns[$i]]=$response[$columns[$i]][$k];
				   $k++;
            for($j=2;$j<=sizeof($arreglo);$j++)
            {
            
             
              $response[$columns[$i]."_$j"]=$arreglo[$k];
              array_push($arr, $response[$columns[$i]."_$j"]);
              $k++;
                  
            }
 //  chcm. junio 12 2007     $response[$columns[$i]] = join(',', $response[$columns[$i]]);
       
				}
			 
		
    	switch ($types[$i]) {
			case 2: /* special */
				break;
			case 1: /* string */
				if (isset($response[$columns[$i]])) {
					$response[$columns[$i]] = ereg_replace("[\n\t]", ' ', $response[$columns[$i]]);
					$response[$columns[$i]] = ereg_replace('"', '""', $response[$columns[$i]]);
					$response[$columns[$i]] = '"'. $response[$columns[$i]] .'"';
				} 
				/* fall through */
			case 0: /* number */
				if (isset($response[$columns[$i]]))
					array_push($arr, $response[$columns[$i]]);
				else
					array_push($arr, '');
				break;
    }		
		
    }
    }//else
    
		if (sizeof($arr)>0)
		  array_push($output, $arr);
	}
	/*
    CREADO POR CARLOS CERON.
    FECHA: MAYO 14 2007
    VERIFICO SI YA HAY UN REGISTRO CON EL MISMO ID DE USUARIO, DE MODULO Y 
    DE CURSO PARA NO METERLO EN EL VECTOR FINAL, ESTO ES PORQUE HAY UN REQUISITO
    QUE DICE QUE NO DEBEN HABER VALORES DUPLICADOS EN EL VECTOR FINAL
  */
  
 	
   if($ceddet==1)
   {
      $vector_resultado=array();
	    $vector_resultado[0]=$output[0]; //pongo los titulos de las preguntas
	    $tamano_arreglo_usuarios=sizeof($arreglo_usuarios);
	    $contador_aux = $tamano_arreglo_usuarios;

	
	    for($i=sizeof($output)-1;$i>0;$i--)
	    {
	  
      
         $contador_aux--;
      
         if (sizeof($vector_resultado)==1)
          {
            $vector_resultado[]=$output[$i];
           $vector_auxiliar_usuarios[]=$arreglo_usuarios[$contador_aux];  
          }
         else
          {
          //verifico si ya est en el vector resultado para no meterlo de nuevo
       
            if (!in_array($arreglo_usuarios[$contador_aux],$vector_auxiliar_usuarios))
            {
            $vector_resultado[]=$output[$i];
            $vector_auxiliar_usuarios[]=$arreglo_usuarios[$contador_aux]; 
            }
             else
            {
               //ya esta en el vector, no lo agregue porque es repetido
            }
        
             }
      
       }
   }// if $ceddet==1
   else
   $vector_resultado = $output;
	  mysql_free_result($result);
		//i($vector_resultado);exit;
    return $vector_resultado;
}
/* }}} */

/* {{{ proto bool survey_export_csv(int survey_id, string filename)
	Exports the results of a survey to a CSV file.
	Returns true on success.
	*/
function survey_export_csv($sid, $filename, $separator,$idcurso="",$idmodulo="") { //JS 06JUL2006 - se aade el separador 
	//$umask = umask(0777);
	$fh = fopen($filename, 'w');
	// umask($umask);
	chmod($filename, 0777);  
	if(!$fh)
		return 0;
	
	$data = survey_generate_csv($sid,$idcurso,$idmodulo);

	foreach ($data as $row) {
		fputs($fh, join( $separator, $row) . "\n"); // JS 06JUL2006 - se aade el separador
	}
	
	fflush($fh);
	fclose($fh);
	
	return 1;
}





 function obtenerValorResponse($sid,$content)
 {/*Function que retorna el valor del campo response de la tabla response_text
 de acuerdo al $sid y $content que pasan por parametros, se consulta en la tabla question para obtener el id de acuerdo al $sid y $content, con ese id se va a la tabla response_text y se saca el campo response.
 Creado por : CARLOS H. CERON MEZA
 FECHA: MAYO 04 2007
 Funcin creada para satisfacer requisitos de CEDDET
 */
 
    $sql = "select id from question where survey_id=$sid and content='$content'";
    $result_q = mysql_query($sql);
    $fila = mysql_fetch_array($result_q);
    $qid = $fila['id'];
    $sql = "select response from response_text where question_id=$qid";
    $result_r = mysql_query($sql);
    
    $respuestas = "";
    if ($result_r) 
    while(list($response) = mysql_fetch_row($result_r))
    {
      $respuestas[] = $response; 
    }
    return $respuestas;
 }
 
 function i($vector)
 {
    echo "<pre>";
      print_r($vector);
    echo "</pre>";
 }

/* }}} */
?>
