<?php



# $Id: export.inc,v 1.4 2002/04/05 18:20:48 jimmerman Exp $



// Written by James Flemer

// <jflemer@acm.jhu.edu>



$sid = intval($_GET['sid']);

if(!empty($_POST['sid']))

	$sid = intval($_POST['sid']);



?>

<h2><?php echo(_('Export Data')); ?></h2>

<?php echo("<a href=\"". $GLOBALS['ESPCONFIG']['ME'] ."?where=manage\">" . _('Go back to Management Interface') . "</a>\n"); ?>

<table border="0" align="center" cellspacing="0" cellpadding="4" bgcolor="<?php echo($ESPCONFIG['active_bgcolor']); ?>" width="95%">

<?php



/* If the Survey ID is not given, then build 

 * a menu of available surveys to chose from.

 */

if(!$sid) {

?>

	<tr bgcolor="#dddddd">

		<th align="left"><?php echo(_('ID')); ?></th>

		<th align="left"><?php echo(_('Name')); ?></th>

		<th align="left"><?php echo(_('Title')); ?></th>

		<th align="left"><?php echo(_('Owner')); ?></th>

		<th align="left"><?php echo(_('Group')); ?></th>

		<th align="left"><?php echo(_('Status')); ?></th>

		<th align="left" colspan="2" ><?php echo(_('Format')); ?></td>

	</tr>

<?php

	/* load names and titles of all surveys available to

	 * _this_ user */

	$statusok = (STATUS_ACTIVE | STATUS_DONE & ~STATUS_DELETED);

	if($HTTP_SESSION_VARS['acl']['superuser'] == 'Y') {

		$sql = "SELECT id,name,title,status,owner,realm FROM survey 

		WHERE (status & $statusok) ORDER BY id DESC";

	} else {

		$realms = array_to_insql(

			array_intersect(

				$HTTP_SESSION_VARS['acl']['pall'],

				$HTTP_SESSION_VARS['acl']['pdata']));

		$sql = "SELECT id,name,title,status,owner,realm

			FROM survey WHERE (status & $statusok) AND (owner = '".

			$HTTP_SESSION_VARS['acl']['username'] ."' || realm $realms) ORDER BY id DESC";

	}

	$result = mysql_query($sql);



	while(list($sid,$name,$title,$status,$owner,$realm) = mysql_fetch_row($result)) {

		$stat = _('Editing');

		

		if($status & STATUS_DELETED) {

			$stat = _('Archived');

			continue;

		} elseif($status & STATUS_DONE) {

			$stat = _('Ended');

		} elseif($status & STATUS_ACTIVE) {

			$stat = _('Active');

		} elseif($status & STATUS_TEST) {

			$stat = _('Testing');

		}

						

		if($bg != $ESPCONFIG['bgalt_color1'])

			$bg = $ESPCONFIG['bgalt_color1'];

		else

			$bg = $ESPCONFIG['bgalt_color2'];

?>

	<tr bgcolor="<?php echo($bg); ?>">

		<td><?php echo($sid); ?></td>

		<td><?php echo($name); ?></td>

		<td><?php echo($title); ?></td>

		<td><?php echo($owner); ?></td>

		<td><?php echo($realm); ?></td>

		<td><?php echo($stat); ?></td>

		<td>

			<!-- JS separador tambin para el CSV en servidor 

			<?php echo("<a href=\"". $GLOBALS['ESPCONFIG']['ME'] ."?where=export&type=csv&sid=$sid\">" . _('CSV') . "</a>"); ?> 

			

			<?php echo("<a href=\"". $GLOBALS['ESPCONFIG']['ME'] ."?where=export&type=csv&sid=$sid&separator=,\">" . _('CSV1') . "</a>"); ?>

			<?php echo("<a href=\"". $GLOBALS['ESPCONFIG']['ME'] ."?where=export&type=csv&sid=$sid&separator=;\">" . _('CSV2') . "</a>"); ?>

      JS-->
			<!--(<?php

			// echo("<a href=\"". $GLOBALS['ESPCONFIG']['ME'] ."?where=download&type=csv&sid=$sid\">" . _('download') . '</a>'); ?>)</td>

			-->

			<!-- JS following lines to have two kinds of separators : , and ; -->

      

			(<?php echo("<a href=\"". $GLOBALS['ESPCONFIG']['ME'] ."?where=download&type=csv&sid=$sid&separator=,\">" . _('download1') . '</a>'); ?>)

			(<?php echo("<a href=\"". $GLOBALS['ESPCONFIG']['ME'] ."?where=download&type=csv&sid=$sid&separator=;\">" . _('download2') . '</a>'); ?>)
			
			(<?php echo("<a href=\"". $GLOBALS['ESPCONFIG']['ME'] ."?where=download&type=csv&sid=$sid&separator=;&download_full=1\">" . _('download2 with timestamp & RID') . '</a>'); ?>)
      
      <?php echo "<a href=\"{$GLOBALS['ESPCONFIG']['ME']}?where=respuestas&type=html&sid=$sid\">HTML</a>"; ?>
      </td>

		<td>&nbsp;<!-- <?php

			echo("<a href=\"". $GLOBALS['ESPCONFIG']['ME'] ."?where=export&type=dbf&sid=$sid\">" . _('DBF') . "</a>"); ?>  --></td>

	</tr>

<?php

	}

?>

</table>

<?php echo("<a href=\"". $GLOBALS['ESPCONFIG']['ME'] ."?where=manage\">" . _('Go back to Management Interface') . "</a>\n"); ?>

<?php

	return;

	}

	

	/* sid supplied ... continue */

	$sql = "SELECT name FROM survey WHERE id = $sid";

	$result = mysql_query($sql);

	$name = mysql_result($result, 0, 0);

	mysql_free_result($result);



	/* check ACLs for permissions */

	$srealm = auth_get_survey_realm($sid);

	if($_GET['test']) {

		/* check ACL to see if user is allowed to test

		 * _this_ survey */

		if($HTTP_SESSION_VARS['acl']['superuser'] != 'Y' &&

				!auth_is_owner($sid, $HTTP_SESSION_VARS['acl']['username']) &&

				!in_array($srealm, array_intersect(

						$HTTP_SESSION_VARS['acl']['pdesign'],

						$HTTP_SESSION_VARS['acl']['pall'])) &&

				!auth_no_access(_('to access this survey'))) {

			return;

		}

		echo("<p><b>". _('Testing Survey...') ."</b> (". _('SID') ." = $sid)</p>\n");

	} else {

		/* check ACL to see if user is allowed to export

		 * _this_ survey */

		if($HTTP_SESSION_VARS['acl']['superuser'] != 'Y' &&

				!auth_is_owner($sid, $HTTP_SESSION_VARS['acl']['username']) &&

				!in_array($srealm, array_intersect(

						$HTTP_SESSION_VARS['acl']['pdata'],

						$HTTP_SESSION_VARS['acl']['pall'])) &&

				!auth_no_access(_('to access this survey'))) {

			return;

		}

	}



	$type = isset($_GET['type']) ? $_GET['type'] : 'csv';

	

	// Try DBF first, default to CSV

	if($type == 'dbf') {

		$file = $HTTP_SESSION_VARS['acl']['home'] . "/$name.dbf";

		if(extension_loaded('dbase')) {

			$ret = survey_export_dbf($sid, $file);

		} else {

			$ret = 0;

			echo("<tr><td>" . mkerror(_('The PHP dBase Extension is not installed.')) . "</td></tr>");

		}

	} else {

		$file = $HTTP_SESSION_VARS['acl']['home'] . "/$name.csv";

		$ret = survey_export_csv($sid, $file, $separator); //JS 06JUL2006 se aade el separador

	}



	echo("<tr><td>");

	if($_GET['test']) {

		echo("<p><b>". _('Testing Survey...') ."</b> (". _('SID') ." = $sid)</p>\n");

	}

	if($ret) {

		echo(_('Survey exported as:') . " <tt>$file</tt>");

		echo("   <a href=\"http://www.querytek.com/survey-download/".$name.".csv\">Click here to download</a>");

	} else {

		echo(mkwarn(_('Error exporting survey as:') . " <tt>$file</tt>"));

	}

	echo("</td></tr></table>\n");

	echo("<a href=\"". $GLOBALS['ESPCONFIG']['ME'] ."?where=manage\">" . _('Go back to Management Interface') . "</a>\n");

	

?>

